<?php
class GFPollsFormSettings {

    public static function form_settings_page() {
        $form_id = rgget('id');
        $form        = RGFormsModel::get_form_meta($form_id);
        $poll_fields = GFCommon::get_fields_by_type($form, array('poll'));
        if (empty($poll_fields)){
            GFFormSettings::page_header(__("Polls Form Settings", "gravityformspolls"));
            echo "<h3><span>" . __("Polls Form Settings", "gravityformspolls") . "</h3>";
            _e("This form doesn't have any poll fields.");
            GFFormSettings::page_footer();
            return;
        }
        if(rgpost('gform_meta')) {

            // die if not posted from correct page
            check_admin_referer("gform_save_form_settings_{$form_id}", 'gform_save_form_settings');

            $updated_form = json_decode(rgpost('gform_meta'), true);
            $updated_form['fields'] = $form['fields'];

            require_once(GFCommon::get_base_path() . '/form_detail.php');
            $update_result = GFFormDetail::save_form_info($form_id, addslashes(json_encode($updated_form)));

            // update working form object with updated form object
            $form = $updated_form;
        }

        ?>
        <script type="text/javascript">
        <?php GFCommon::gf_global(); ?>
        <?php GFCommon::gf_vars(); ?>

        var form = <?php echo json_encode($form); ?>;
        var fieldSettings = [];
        </script>
        <?php
        GFFormSettings::page_header(__("Polls Form Settings", "gravityformspolls"));
        ?>
    <div class="gform_panel gform_panel_form_settings" id="form_settings">
        <h3><span><?php _e("Polls Form Settings", "gravityformspolls"); ?></span></h3>

        <form action="" method="post" id="gform_form_settings">
            <div id="gpoll-form-settings">
                <ul>
                    <li>
                        <input type="checkbox" id="gpoll-form-setting-display-results"
                               onclick="gpollSetFormProperty('gpollDisplayResults', this.checked)"/> <label
                            for="gpoll-form-setting-display-results"><?php _e("Display results of submitted poll fields", "gravityformspolls") ?> <?php gform_tooltip("gpoll_form_settings_display_results") ?></label>
                    </li>
                    <li>
                        <input type="checkbox" id="gpoll-form-setting-show-results-link"
                               onclick="gpollSetFormProperty('gpollShowResultsLink', this.checked)"/> <label
                            for="gpoll-form-setting-show-results-link"><?php _e("Show link to view results", "gravityformspolls") ?> <?php gform_tooltip("gpoll_form_settings_show_results_link") ?></label>
                    </li>
                    <li>
                        <input type="checkbox" id="gpoll-form-setting-show-percentages"
                               onclick="gpollSetFormProperty('gpollShowPercentages', this.checked)"/> <label
                            for="gpoll-form-setting-show-percentages"><?php _e("Show percentages", "gravityformspolls") ?> <?php gform_tooltip("gpoll_form_settings_show_percentages") ?></label>
                    </li>
                    <li>
                        <input type="checkbox" id="gpoll-form-setting-show-counts"
                               onclick="gpollSetFormProperty('gpollShowCounts', this.checked)"/> <label
                            for="gpoll-form-setting-show-counts"><?php _e("Show counts", "gravityformspolls") ?> <?php gform_tooltip("gpoll_form_settings_show_counts") ?></label>
                    </li>
                    <li class="gform_setting_left_half">
                        <label style="display:block;"
                               for="gpoll-form-setting-style"><?php _e("Style", "gravityformspolls"); ?>:</label>
                        <select id="gpoll-form-setting-style" name="gpoll-form-setting-style" style="width:90%;"
                                onchange="gpollSetFormProperty('gpollStyle', this.value)">
                            <option value="green"><?php _e("Green", "gravityformspolls") ?></option>
                            <option value="blue"><?php _e("Blue", "gravityformspolls") ?></option>
                            <option value="red"><?php _e("Red", "gravityformspolls") ?></option>
                            <option value="orange"><?php _e("Orange", "gravityformspolls") ?></option>
                        </select>
                    </li>
                    <li>
                        <h4 class="gf_settings_subgroup_title"><?php _e("Repeat Voters", "gravityformspolls"); gform_tooltip("gpoll_form_settings_repeat_voters") ?></h4>
                        <input type="radio" name="gpoll-form-setting-block-repeat-voters" value="0"
                               id="gpoll-form-setting-block-repeat-voters-0"
                               onclick="gpollSetFormProperty('gpollBlockRepeatVoters', false);jQuery('#gpoll-form-setting-cookie-options').hide('slow');">
                        <label for="gpoll-form-setting-block-repeat-voters-0"><?php _e("Don't block repeat voting", "gravityformspolls"); ?></label><br>
                        <input type="radio" name="gpoll-form-setting-block-repeat-voters" value="1"
                               id="gpoll-form-setting-block-repeat-voters-1"
                               onclick="gpollSetFormProperty('gpollBlockRepeatVoters', true);jQuery('#gpoll-form-setting-cookie-options').show('slow');">
                        <label for="gpoll-form-setting-block-repeat-voters-1"><?php _e("Block repeat voting using cookie", "gravityformspolls"); ?></label><br>

                        <div id="gpoll-form-setting-cookie-options" style="width:44%; display:none;">
                            <br>
                            <label style="display:block;"
                                   for="gpoll-form-setting-cookie"><?php _e("Expires:", "gravityformspolls"); ?></label>
                            <select id="gpoll-form-setting-cookie" name="gpoll-form-setting-cookie" style="width:90%;"
                                    onchange="gpollSetFormProperty('gpollCookie', this.value)">
                                <option value="20 years"><?php _e("Never", "gravityformspolls") ?></option>
                                <option value="1 hour"><?php _e("1 hour", "gravityformspolls") ?></option>
                                <option value="6 hours"><?php _e("6 hours", "gravityformspolls") ?></option>
                                <option value="12 hours"><?php _e("12 hours", "gravityformspolls") ?></option>
                                <option value="1 day"><?php _e("1 day", "gravityformspolls") ?></option>
                                <option value="1 week"><?php _e("1 week", "gravityformspolls") ?></option>
                                <option value="1 month"><?php _e("1 month", "gravityformspolls") ?></option>
                            </select>
                        </div>

                    </li>
                </ul>
            </div>
            <?php if(GFCommon::current_user_can_any("gravityforms_edit_settings")){ ?>
            <br/><br/>
            <?php wp_nonce_field("gform_save_form_settings_{$form_id}", 'gform_save_form_settings'); ?>
            <input type="hidden" id="gform_meta" name="gform_meta" />
            <input type="button" id="gform_save_settings" name="gform_save_settings" value="Update Form Settings" class="button-primary gfbutton" onclick="SaveFormSettings();" />

            <?php } ?>
        </form>
    </div>
    <?php
        GFFormSettings::page_footer();

    }


}

